--------------------------------------------------------------------------
-- AISYSTEM
--
-- Copyright (C) 2012-Present. All rights reserved.
--
-- See LICENSE.TXT document for licensing information.
--------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
						   
library work;
use work.common.all;
					   
package definition is
	-- nodes
	type node_record is record
		id							: node_type;
		address						: string(1 to 23);
		status						: std_logic;
	end record;	

	type node_array is array (0 to SIZE_NODE_COUNT - 1) of node_record;

	-- nodes that need be inserted or deleted
	constant NODE_STATUS_INSERT 	: integer := 0;
	constant NODE_STATUS_DELETE 	: integer := 1;
	
	type node_status_record is record
		address						: string(1 to 23);
		status						: std_logic;
	end record;	

	type node_status_array is array (0 to SIZE_NODE_COUNT - 1) of node_status_record;
end package;

package body definition is
end package body definition;

