-------------------------------------------------------------------------------
-- 
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_cos.all;

entity fp_sin_cos_cos is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+1 downto 0);
         r : out std_logic_vector(wF+2 downto 0) );
end entity;

architecture arch of fp_sin_cos_cos is
begin -------------------------------------------------------------------------

  cos_10 : if wF = 10 generate
    cos : fp_sin_cos_cos_10
      port map ( x => x,
                 r => r );
  end generate;

  cos_13 : if wF = 13 generate
    cos : fp_sin_cos_cos_13
      port map ( x => x,
                 r => r );
  end generate;

  cos_16 : if wF = 16 generate
    cos : fp_sin_cos_cos_16
      port map ( x => x,
                 r => r );
  end generate;

  cos_20 : if wF = 20 generate
    cos : fp_sin_cos_cos_20
      port map ( x => x,
                 r => r );
  end generate;

  cos_23 : if wF = 23 generate
    cos : fp_sin_cos_cos_23
      port map ( x => x,
                 r => r );
  end generate;

end architecture; -------------------------------------------------------------
