library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library fplib;
use fplib.pkg_fp_sin_cos.all;
use fplib.pkg_misc.all;

package pkg_trig is

  function fp_sin_cos_latency ( wE, wF : positive ) 
    return positive;

component Sin_Cos is
  generic ( wE : positive := 6;
            wF : positive := 13 );
  port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
         fpS : out std_logic_vector(wE+wF+2 downto 0);
         fpC : out std_logic_vector(wE+wF+2 downto 0) );
end component;

component Sin_Cos_2Pi is
  generic ( wE : positive := 6;
            wF : positive := 13 );
  port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
         fpS : out std_logic_vector(wE+wF+2 downto 0);
         fpC : out std_logic_vector(wE+wF+2 downto 0) );
end component;

-- component Sin_Cos_Clk is
--   generic ( wE : positive := 6;
--             wF : positive := 13 ;
--             reg : boolean  := true;
--             SzSlk  : natural  := 0 );
--   port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
--          fpS : out std_logic_vector(wE+wF+2 downto 0);
--          fpC : out std_logic_vector(wE+wF+2 downto 0);
--          clk : in  std_logic );

-- end component;

function sin_cos_latency ( wE, wF : positive; SzSlk  : natural ) 
    return positive;

function sin_cos_2pi_latency ( wE, wF : positive; SzSlk  : natural ) 
    return positive;

end package;

package body pkg_trig is

  
  function fp_sin_cos_latency ( wE, wF : positive ) return positive is
     begin
    return 1;                           --hack: used for comb version
  end function;

  function fp_sin_cos_2pi_latency ( wE, wF : positive ) return positive is
     begin
    return 1;                           --hack: used for comb version
  end function;
  
  function sin_cos_latency ( wE, wF : positive; SzSlk: natural ) return positive is
    constant eLat   : positive := fp_sin_cos_latency ( wE, wF);
  begin
    return ( eLat + SzSlk );
  end function;

  function sin_cos_2pi_latency ( wE, wF : positive; SzSlk: natural ) return positive is
    constant eLat   : positive := fp_sin_cos_2pi_latency ( wE, wF);
  begin
    return ( eLat + SzSlk );
  end function;

end package body;
------------------------------------------------------
------------------------------------------------------
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library fplib;
use fplib.pkg_fp_sin_cos.all;

entity Sin_Cos is
  generic ( wE : positive := 6;
            wF : positive := 13 );
  port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
         fpS : out std_logic_vector(wE+wF+2 downto 0);
         fpC : out std_logic_vector(wE+wF+2 downto 0) );
end entity;

architecture arch of Sin_Cos is
  
--  component fp_sin_cos is
--   generic ( wE : positive := 6;
--             wF : positive := 13 );
--   port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
--          fpS : out std_logic_vector(wE+wF+2 downto 0);
--          fpC : out std_logic_vector(wE+wF+2 downto 0) );
--  end component;
 
begin
    i0_sin_cos : fp_sin_cos
      generic map  (wE => wE, wF => wF)
      port    map  (fpX=> fpX, fpS => fpS, fpC => fpC);
end architecture;

------------------------------------------------------
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
library fplib;
use fplib.pkg_fp_sin_cos.all;

entity Sin_Cos_2Pi is
  generic ( wE : positive := 6;
            wF : positive := 13 );
  port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
         fpS : out std_logic_vector(wE+wF+2 downto 0);
         fpC : out std_logic_vector(wE+wF+2 downto 0) );
end entity;

architecture arch of Sin_Cos_2Pi is
  
--  component fp_sin_cos_2pi is
--   generic ( wE : positive := 6;
--             wF : positive := 13 );
--   port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
--          fpS : out std_logic_vector(wE+wF+2 downto 0);
--          fpC : out std_logic_vector(wE+wF+2 downto 0) );
--  end component;
 
begin
    i0_sin_cos_2pi : fp_sin_cos_2pi
      generic map  (wE => wE, wF => wF)
      port    map  (fpX=> fpX, fpS => fpS, fpC => fpC);
end architecture;


-- use ieee.std_logic_1164.all;
-- use ieee.std_logic_arith.all;
-- use ieee.std_logic_unsigned.all;

-- library fplib;
-- use fplib.pkg_fp_sin_cos.all;
-- use fplib.pkg_misc.all;

-- entity Sin_Cos_Clk is
--   generic (
--             wE  : positive := 6;
--             wF  : positive := 13;
--             reg : boolean  := true;
--             SzSlk  : natural  := 0 );
--   port ( fpX : in  std_logic_vector(wE+wF+2 downto 0);
--          fpS : out std_logic_vector(wE+wF+2 downto 0);
--          fpC : out std_logic_vector(wE+wF+2 downto 0);
--          clk : in  std_logic );
-- end entity;

-- architecture arch of Sin_Cos_Clk is
--   signal pipebuf_fpS  : std_logic_vector(wE+wF+2 downto 0);
--   signal pipebuf_fpC  : std_logic_vector(wE+wF+2 downto 0);
-- begin
--     wreg : if reg = true generate
--       sincosreg : fp_sin_cos_clk
--         generic map ( wE => wE, wF => wF )
--         port    map (fpX=> fpX, fpS => pipebuf_fpS, fpC => pipebuf_fpC, clk => clk);
      
--       wPipeBuf : if SzSlk>=0 generate
--         sin_pipeBuf: fplib.pkg_misc.Delay
--           generic map (w=>wE+wF+2+1, n=> SzSlk)
--           port    map (input=> pipebuf_fpS, output=>fpS, clk=> clk);
--         cos_pipeBuf: fplib.pkg_misc.Delay
--           generic map (w=>wE+wF+2+1, n=> SzSlk)
--           port    map (input=> pipebuf_fpC, output=>fpC, clk=> clk);
--       end generate;    
--     end generate;

--     woreg_woPipeBuf : if reg = false generate
--       sincoscmb : fp_sin_cos
--         generic map ( wE => wE, wF => wF )
--         port    map (fpX=> fpX, fpS => fpS, fpC => fpC);
--     end generate;
       
--end architecture;

