--------------------------------------------------------------------------
-- AISYSTEM
--
-- Copyright (C) 2012-Present. All rights reserved.
--
-- See LICENSE.TXT document for licensing information.
--------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library ieee_proposed;
use ieee_proposed.fixed_float_types.all;
use ieee_proposed.fixed_pkg.all;
use ieee_proposed.float_pkg.all;
	 
library work;
use work.common.all;
		  
-- test for objectX

entity caseX is
end;

architecture bench of caseX is
	component objectX
		generic
		(
			CLK_FREQUENCY   : integer := 1
		);    
		port 
		(
			reset           : in std_logic;
			clock           : in std_logic
		);
	end component;

	constant CLOCK_PERIOD	: time := 10 ns;

	signal reset			: std_logic;
	signal clock			: std_logic;
	signal is_stopped		: boolean;
begin
	-- values for generic parameters
	uut: objectX 
		generic map 
		(
			CLK_FREQUENCY => 10
		)
		port map 
		(
			reset   => reset,
			clock   => clock
		);

	stimulus : process
	begin
		-- initialization

		reset <= '1';
		wait for 5 ns;
		reset <= '0';
		wait for 5 ns;

		-- stimulus

		is_stopped <= true;
		wait;
	end process;

	generation : process
	begin
		while not is_stopped loop
			clock <= '0', '1' after CLOCK_PERIOD / 2;
			wait for CLOCK_PERIOD;
		end loop;
		wait;
	end process;
end architecture;
  
